<?php
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
//////■ 以下スクリプト ■////
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
mb_language("japanese");
mb_internal_encoding("UTF-8");

// 外部ファイル読み込み
require_once('./config.php');
require_once($GLOBALS['path']['php']['system']);

configread(); // 設定データ取得
requestdecode(); // リクエストデコード
noveldata(); // 小説データ取得

// 処理分岐
if (!empty($_REQUEST['password'])) {
	if ($_REQUEST['password'] !== $GLOBALS['mskey']) {
		setcookie('password', '', $GLOBALS['nowtime'] - 3600, '/', $_SERVER['SERVER_NAME']);
		error('パスワードが違います。');
	}

	// パスワードクッキーセット
	if (!empty($_GET['password'])) {
		setcookie('password', $_REQUEST['password'], $GLOBALS['nowtime'] + 60 * 60, '/', $_SERVER['SERVER_NAME']);
	}

	if ($_GET['mode'] === 'config_base') {
		config_base();
	} else if ($_GET['mode'] === 'novel_base_new' || $_GET['mode'] === 'novel_base_edit') {
		novel_base_form();
	} else if ($_GET['mode'] === 'novel_list') {
		novel_list();
	} else if ($_GET['mode'] === 'novel_edit') {
		novel_edit();
	} else if ($_GET['mode'] === 'chapter_new' || $_GET['mode'] === 'chapter_edit') {
		chapter_form();
	} else if ($_GET['mode'] === 'text_new' || $_GET['mode'] === 'text_edit') {
		text_form();
	} else if ($_GET['mode'] === 'clap_message') {
		clap_message();
	} else if ($_GET['mode'] === 'clap_option') {
		clap_option();
	}

	else if (count($_POST) > 0) {
		formid_check();

		if ($_POST['mode'] === 'config_base_write') {
			config_base_write();
		} else if ($_POST['mode'] === 'novel_base_new_write') {
			novel_base_new_write();
		} else if ($_POST['mode'] === 'novel_base_edit_write') {
			novel_base_edit_write();
		} else if ($_POST['mode'] === 'novel_delete_write') {
			novel_delete_write();
		} else if ($_POST['mode'] === 'chapter_new_write') {
			chapter_new_write();
		} else if ($_POST['mode'] === 'chapter_edit_write') {
			chapter_edit_write();
		} else if ($_POST['mode'] === 'chapter_delete_write') {
			chapter_delete_write();
		} else if ($_POST['mode'] === 'text_new_write') {
			text_new_write();
		} else if ($_POST['mode'] === 'text_edit_write') {
			text_edit_write();
		} else if ($_POST['mode'] === 'text_delete_write') {
			text_delete_write();
		} else {
			top();
		}
	} else {
		top();
	}
} else {
	login();
}
exit;
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ヘッダ・フッタ
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function htmlheader($top = '') {
	htmlstart();

	echo '
	<div data-role="header" data-theme="'. $GLOBALS['CSTM']['mt_main']. '">
		';
		if ($top == 1) {
			echo '<h1 style="text-align: left; margin-left: 10px;">管理画面</h1>';
		} else {
			echo '
			<h3>&nbsp;</h3>
			<div data-role="controlgroup" data-type="horizontal" class="ui-btn-left">
				<a href="'. $GLOBALS['path']['php']['main']. '?" data-role="button">ログアウト</a>
				';
				if (isset($GLOBALS['NOVEL'][$_GET['nvno']]['title'])) {
					echo '
					<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_edit&nvno='. $_REQUEST['nvno']. '"
					 data-role="button" rel="external" class="title-btn"><div class="text-over">'. $GLOBALS['NOVEL'][$_GET['nvno']]['title']. '</div></a>
					';
				}
				echo '
			</div>
			';
		}

		if (!empty($GLOBALS['CSTM']['homeurl'])) {
			echo '
			<a href="'. $GLOBALS['CSTM']['homeurl']. '" data-role="button" data-icon="home" data-iconpos="notext" rel="external" class="ui-btn-right">HOME</a>
			';
		}

		echo '
	</div>
	<div id="pagewrap">
		<div id="contents-main">
			<div data-role="content">
			';
}
function htmlfooter() {
			echo '
			</div>
		</div>
		<div id="contents-side">
			<ul data-role="listview" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_sub']. '">
				<li data-role="list-divider">管理メニュー <small>[<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '">?</a>]</small></li>
				<li><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_base_new">
					<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['pencil']. '" class="ui-li-icon list-admin-icon" />
					小説作成
				</a></li>
				<li><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_list">
					<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['book']. '" class="ui-li-icon list-admin-icon" />
					小説一覧
				</a></li>
				'. (($GLOBALS['CSTM']['webclap'] == 1) ? '
					<li><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_message">
						<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['comment']. '" class="ui-li-icon list-admin-icon" />
						WEB拍手
					</a></li>
				' : ''). '
				<li><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=config_base">
					<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['gear']. '" class="ui-li-icon list-admin-icon" />
					設定
				</a></li>
			</ul>
		</div>
		<div style="clear: both;"></div>
	</div>
	<div data-role="footer" data-theme="'. $GLOBALS['CSTM']['mt_main']. '">
		<h3>&nbsp;</h3>
		<div data-role="controlgroup" data-type="horizontal" class="ui-btn-left">
			<a href="'. $GLOBALS['path']['php']['main']. '?" data-role="button">ログアウト</a>
		</div>
		';

		htmlend();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ログイン
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function login() {
	htmlstart();

	echo <<< _HTML_
<div data-role="header" data-theme="{$GLOBALS['CSTM']['mt_main']}">
	<h3>&nbsp;</h3>
	<a href="{$GLOBALS['path']['php']['main']}?" data-role="button" data-role="button" data-icon="back" class="ui-btn-left">戻る</a>
	<a href="{$GLOBALS['CSTM']['homeurl']}" data-role="button" data-icon="home" data-iconpos="notext" rel="external" class="ui-btn-right">HOME</a>
</div>
<div data-role="content">
	<form method="get">
		<div data-role="fieldcontain">
			<label for="password">管理者パスワード:</label>
			<input type="password" name="password" id="password" value="{$_COOKIE['password']}" />
		</div>
		<div data-role="fieldcontain">
			<label for="submit"></label>
			<button type="submit" id="submit">ログイン</button>
		</div>
	</form>
</div>
<div data-role="footer" data-theme="{$GLOBALS['CSTM']['mt_main']}">
	<h3>&nbsp;</h3>
	<a href="{$GLOBALS['path']['php']['main']}?" data-role="button" data-role="button" data-icon="back" class="ui-btn-left">戻る</a>
_HTML_;

	htmlend();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ トップページ
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function top() {
	htmlheader(1);

	echo '
	<ul data-role="listview" data-inset="true" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '">
		<li data-role="list-divider">管理メニュー</li>
		<li><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_base_new">
			<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['pencil']. '" class="ui-li-icon list-admin-icon" />
			<h4>小説作成</h4>
			<p>新しく小説を作成出来ます。</p>
		</a></li>
		<li><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_list">
			<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['book']. '" class="ui-li-icon list-admin-icon" />
			<h4>小説一覧</h4>
			<p>既存の小説を確認出来ます。小説の修正・削除などの編集をする場合はこちらから行ってください。</p>
		</a></li>
		'. (($GLOBALS['CSTM']['webclap'] == 1) ? '
		<li><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_message">
			<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['comment']. '" class="ui-li-icon list-admin-icon" />
			<h4>WEB拍手</h4>
			<p>WEB拍手で送信された拍手、メッセージの確認が出来ます。</p>
		</a></li>
		' : ''). '
		<li><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=config_base">
			<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['gear']. '" class="ui-li-icon list-admin-icon" />
			<h4>設定</h4>
			<p>HOME URL、メインタイトルなど基本設定、WEB拍手、Twitterの各設定が行えます。</p>
		</a></li>
	</ul>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ WEB拍手
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function clap_message() {
	$nowtime = $GLOBALS['nowtime'];
	$stttime = $nowtime;
	$endtime = $nowtime;

	if (!empty($_GET['datesel'])) { // ※未実装
		$stttime = mktime(0, 0, 0, $_GET['s_month'], $_GET['s_day'], $_GET['s_year']);
		$endtime = mktime(0, 0, 0, $_GET['e_month'], $_GET['e_day'], $_GET['e_year']);
	} elseif (!empty($_GET['specify'])) {
		if ($_GET['specify'] === 'yesterday') {
			$stttime -= 60 * 60 * 24;
		} elseif ($_GET['specify'] === 'week') {
			$stttime -= 60 * 60 * 24 * 6;
		} elseif ($_GET['specify'] === 'month') {
			$stttime = strtotime(date('Y-m-d').' -1 month');
		}
	} elseif (!empty($_GET['year']) && !empty($_GET['month']) && !empty($_GET['day'])) {
		$stttime = mktime(0, 0, 0, $_GET['month'], $_GET['day'], $_GET['year']);
		$endtime = $stttime;
	} elseif (!empty($_GET['date_start']) || !empty($_GET['date_end'])) {
		$start = date_mktime($_GET['date_start']);
		$end = date_mktime($_GET['date_end']);
		if ($start < $end) {
			$stttime = $start;
			$endtime = $end;
		}
	}

	$year = date("Y", $stttime);
	$month = date("n", $stttime);
	$day = date("j", $stttime);

	htmlheader();

	echo '
	<div data-role="controlgroup" data-type="horizontal" data-mini="true">
		<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_message" data-role="button" data-theme="'. ((empty($_GET['specify'])) ? $GLOBALS['CSTM']['mt_main'] : $GLOBALS['CSTM']['mt_sub']). '">今日</a>
		<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_message&specify=yesterday" data-role="button" data-theme="'. (($_GET['specify'] === 'yesterday') ? $GLOBALS['CSTM']['mt_main'] : $GLOBALS['CSTM']['mt_sub']). '">昨日</a>
		<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_message&specify=week" data-role="button" data-theme="'. (($_GET['specify'] === 'week') ? $GLOBALS['CSTM']['mt_main'] : $GLOBALS['CSTM']['mt_sub']). '">一週間</a>
		<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_message&specify=month" data-role="button" data-theme="'. (($_GET['specify'] === 'month') ? $GLOBALS['CSTM']['mt_main'] : $GLOBALS['CSTM']['mt_sub']). '">一ヶ月</a>
		<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_option" data-role="button" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '">任意</a>
	</div>

	<ul data-role="listview" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '" style="margin: 20px -20px;">
		<li data-role="list-divider">拍手一覧</li>
		<div class="ui-li ui-li-divider ui-bar-'. $GLOBALS['CSTM']['mt_sub']. '">'. (($endtime != $stttime) ? date("Y年n月j日~ ", $endtime) : ''). date("Y年n月j日", $stttime). '</div>
		';

		$allclap = 0;
		$nowpage = (!empty($_GET['page'])) ? $_GET['page'] : 1;
		for ($t = $endtime; $t >= $stttime; $t -= 60 * 60 * 24) {
			$dayfile = $GLOBALS['path']['dir']['data'].'clap/'.date("Y/m-d", $t). '.dat';

			if (file_exists($dayfile)) {

				foreach (array_reverse(file($dayfile)) as $line) {
					list($time, $exnvno, $exctype, $excfmtno, $point, $host, $clap, $name, $tkb, $message) = explode("\t", rtrim($line));

					$allclap++;

					if (($nowpage > 1 && $allclap <= (($nowpage-1) * $GLOBALS['CSTM']['clappgmx']))
					or ($allclap > ($nowpage * $GLOBALS['CSTM']['clappgmx']))) continue;

					echo '
					<li>
						<h4></h4>
						<p><strong>'. $point. '</strong></p>
						'. ((!empty($tkb)) ? '<p>'. $tkb. '</p>' : ''). '
						'. ((!empty($message)) ? '<p>'. $message. '</p>' : ''). '
						<p class="date">
							'. ((!empty($name)) ? '<strong>by '. $name. ' </strong>' : ''). '
							'. date("Y/m/d", $time). '('. $GLOBALS['WEEK'][date("w", $time)]. ')'. date(" H:i", $time). '
							['. $host. ']
						</p>
						<span class="ui-li-count">'. $clap. '</span>
					</li>
					';
				}
			}
		}

		echo '
	</ul>
	';

	// ページ移動
	$url = $GLOBALS['path']['php']['admin'].'?password='.$_REQUEST['password'].'&mode=clap_message'.
			'&specify='.$_GET['specify'].'&datesel='.$_GET['datesel'].
			'&year='.$_GET['year'].'&month='.$_GET['month'].'&day='.$_GET['day'].
			'&s_year='.$_GET['s_year'].'&s_month='.$_GET['s_month'].'&s_day='.$_GET['s_day'].
			'&e_year='.$_GET['e_year'].'&e_month='.$_GET['e_month'].'&e_day='.$_GET['e_day'].
			'&date_start='.urlencode($_GET['date_start']).'&date_end='.urlencode($_GET['date_end']);

	echo '<div data-role="controlgroup" data-type="horizontal" data-mini="true">';

	if ($nowpage != 1) {
		$back = $nowpage - 1;
		echo '<a href="'.$url.'&page='.$back.'" data-role="button" data-icon="arrow-l">前へ</a>';
	} else {
		echo '<a href="#" data-role="button" data-icon="arrow-l" class="disableButton">前へ</a>';
	}

	if (($nowpage * $GLOBALS['CSTM']['clappgmx']) < $allclap) {
		$next = $nowpage + 1;
		echo '<a href="'.$url.'&page='.$next.'" data-role="button" data-icon="arrow-r">次へ</a>';
	} else {
		echo '<a href="#" data-role="button" data-icon="arrow-r" class="disableButton">次へ</a>';
	}

	echo '</div>';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ WEB拍手（日付任意指定）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function clap_option() {
	htmlheader();

	echo '
	<div data-role="controlgroup" data-type="horizontal" data-mini="true">
		<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_message" data-role="button">今日</a>
		<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_message&specify=yesterday" data-role="button">昨日</a>
		<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_message&specify=week" data-role="button">一週間</a>
		<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_message&specify=month" data-role="button">一ヶ月</a>
		<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=clap_option" data-role="button" data-theme="'. $GLOBALS['CSTM']['mt_main']. '">任意</a>
	</div>
	<hr />
	<p>※閲覧したい拍手の日付を、StartからEndまで指定して「表示」ボタンを押してください。</p>
	<form action="'. $GLOBALS['path']['php']['admin']. '?" method="get">
	<input type="hidden" name="password" value="'. $_REQUEST['password']. '" />
	<input type="hidden" name="mode" value="clap_message" />
	<ul data-role="listview" data-inset="true" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '">
		<li data-role="list-divider">日付任意指定</li>
		<li data-role="fieldcontain">
			<label for="date_start"><span class="hissu">*</span>Start:</label>
			<input name="date_start" id="date_start" value="" type="date" data-role="datebox" data-options=\'{"mode": "slidebox"}\'>
		</li>
		<li data-role="fieldcontain">
			<label for="date_end"><span class="hissu">*</span>End:</label>
			<input name="date_end" id="date_end" value="" type="date" data-role="datebox" data-options=\'{"mode": "slidebox"}\'>
		</li>
		<li class="ui-body ui-body-b">
			<button type="submit" data-theme="a">表示</button>
		</li>
	</ul>
	</form>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 基本設定
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function config_base() {
	$formid = formid();

	htmlheader();

	echo '
	<p>※設定するカテゴリを選択し、設定を有効にするには「設定を保存」ボタンを押してください。</p>
	<form action="'. $GLOBALS['path']['php']['admin']. '?" method="post">
	<input type="hidden" name="password" value="'. $_REQUEST['password']. '" />
	<input type="hidden" name="mode" value="config_base_write" />
	<input type="hidden" name="formid" value="'. $formid. '" />
	<div data-role="collapsible-set" data-theme="'. $GLOBALS['CSTM']['mt_main']. '" data-content-theme="'. $GLOBALS['CSTM']['mt_sub']. '" style="margin: 0;">
		<div data-role="collapsible">
			<h3>基本設定</h3>
			<ul data-role="listview">
				<li data-role="fieldcontain">
					<label for="maintitle">メインタイトル:</label>
					<input type="text" name="maintitle" id="maintitle" value="'. $GLOBALS['CSTM']['maintitle']. '"  />
				</li>
				<li data-role="fieldcontain">
					<label for="homeurl">HOME URL:</label>
					<input type="text" name="homeurl" id="homeurl" value="'. $GLOBALS['CSTM']['homeurl']. '"  />
				</li>
				<li data-role="fieldcontain">
					<label for="topmsg">トップページメッセージ:</label>
					<textarea name="topmsg" id="topmsg">'. preg_replace("/<br \/>/", "\n", $GLOBALS['CSTM']['topmsg']). '</textarea>
				</li>
				<li data-role="fieldcontain">
					<label for="maintheme">テーマ配色:</label>
					<select name="maintheme" id="maintheme">
						<option value="blue"'. (($GLOBALS['CSTM']['maintheme'] === 'blue') ? ' selected="selected"' : ''). '>ブルー</option>
						<option value="braun"'. (($GLOBALS['CSTM']['maintheme'] === 'braun') ? ' selected="selected"' : ''). '>ブラウン</option>
						<option value="black"'. (($GLOBALS['CSTM']['maintheme'] === 'black') ? ' selected="selected"' : ''). '>ブラック</option>
						<option value="gray"'. (($GLOBALS['CSTM']['maintheme'] === 'gray') ? ' selected="selected"' : ''). '>グレー</option>
					</select>
				</li>
				<li class="ui-body ui-body-b">
					<button type="submit" data-theme="a">設定を保存</button>
				</li>
			</ul>
		</div>
		<div data-role="collapsible">
			<h3>小説関係</h3>
			<ul data-role="listview">
				<li data-role="fieldcontain">
					<label for="novelpgmx">小説一覧表示件数:</label>
					<input type="range" name="novelpgmx" id="novelpgmx" value="'. $GLOBALS['CSTM']['novelpgmx']. '" min="1" max="10"  />
					<p class="forminfo">トップページの小説一覧の一ページに表示する最大数です。</p>
				</li>
				<li data-role="fieldcontain">
					<label for="novelpgmx">小説一覧表示順序:</label>
					<select name="novelsort" id="novelsort">
						<option value="new_asc"'. (($GLOBALS['CSTM']['novelsort'] === 'new_asc') ? ' selected="selected"' : ''). '>作成順（昇順）</option>
						<option value="new_desc"'. (($GLOBALS['CSTM']['novelsort'] === 'new_desc') ? ' selected="selected"' : ''). '>作成順（降順）</option>
						<option value="up_asc"'. (($GLOBALS['CSTM']['novelsort'] === 'up_asc') ? ' selected="selected"' : ''). '>更新順（昇順）</option>
						<option value="up_desc"'. (($GLOBALS['CSTM']['novelsort'] === 'up_desc') ? ' selected="selected"' : ''). '>更新順（降順）</option>
					</select>
				</li>
				<!-- 
				<li data-role="fieldcontain">
					<label for="mkjnumber">小説目次番号:</label>
					<select name="mkjnumber" id="mkjnumber" data-role="slider">
						<option value="0">非表示</option>
						<option value="1"'. (($GLOBALS['CSTM']['mkjnumber'] == 1) ? ' selected="selected"' : ''). '>表示</option>
					</select>
					<p class="forminfo">小説目次の本文に番号を設けます。サブタイトルを設定しない場合など表示することをお薦めします。</p>
				</li>
				 -->
				<li data-role="fieldcontain">
					<label for="namechenge">名前変換（夢小説）:</label>
					<select name="namechenge" id="namechenge" data-role="slider">
						<option value="0">OFF</option>
						<option value="1"'. (($GLOBALS['CSTM']['namechenge'] == 1) ? ' selected="selected"' : ''). '>ON</option>
					</select>
					<p class="forminfo">「ON」にすると名前変換（夢小説）の設定が可能になります。</p>
				</li>
				<li data-role="fieldcontain">
					<label for="namechenge">予約投稿:</label>
					<select name="reserve" id="reserve" data-role="slider">
						<option value="0">OFF</option>
						<option value="1"'. (($GLOBALS['CSTM']['reserve'] == 1) ? ' selected="selected"' : ''). '>ON</option>
					</select>
					<p class="forminfo">「ON」にすると「小説基本設定」「章」「本文」で予約投稿が可能になります。</p>
				</li>
				<li data-role="fieldcontain">
					<label for="texttheme">小説本文背景色:</label>
					<select name="texttheme" id="texttheme">
						<option value="d"'. (($GLOBALS['CSTM']['texttheme'] === 'd') ? ' selected="selected"' : ''). '>ホワイト</option>
						<option value="c"'. (($GLOBALS['CSTM']['texttheme'] === 'c') ? ' selected="selected"' : ''). '>スモーク</option>
						<option value="b"'. (($GLOBALS['CSTM']['texttheme'] === 'b') ? ' selected="selected"' : ''). '>グレー</option>
						<option value="a"'. (($GLOBALS['CSTM']['texttheme'] === 'a') ? ' selected="selected"' : ''). '>ブラック</option>
					</select>
				</li>
				<li data-role="fieldcontain">
					<label for="cpview">章ページ:</label>
					<select name="cpview" id="cpview" data-role="slider">
						<option value="0">非表示</option>
						<option value="1"'. (($GLOBALS['CSTM']['cpview'] == 1) ? ' selected="selected"' : ''). '>表示</option>
					</select>
					<p class="forminfo">「表示」にすると本文閲覧のページ遷移時に章ページがあった場合その章ページが表示されます。</p>
				</li>
				<li class="ui-body ui-body-b">
					<button type="submit" data-theme="a">設定を保存</button>
				</li>
			</ul>
		</div>
		<div data-role="collapsible">
			<h3>WEB拍手</h3>
			<ul data-role="listview">
				<li data-role="fieldcontain">
					<label for="webclap">WEB拍手:</label>
					<select name="webclap" id="webclap" data-role="slider">
						<option value="0">OFF</option>
						<option value="1"'. (($GLOBALS['CSTM']['webclap'] == 1) ? ' selected="selected"' : ''). '>ON</option>
					</select>
					<p class="forminfo">「ON」にすると小説ページに拍手ボタンが設置され、拍手内容の確認が管理画面から行えるようになります。</p>
				</li>
				<li data-role="fieldcontain">
					<label for="clapcount">拍手数:</label>
					<select name="clapcount" id="clapcount" data-role="slider">
						<option value="0">非表示</option>
						<option value="1"'. (($GLOBALS['CSTM']['clapcount'] == 1) ? ' selected="selected"' : ''). '>表示</option>
					</select>
				</li>
				<li data-role="fieldcontain">
					<label for="claptkb">定形文:</label>
					<textarea name="claptkb" id="claptkb">'. preg_replace("/<br \/>/", "\n", $GLOBALS['CSTM']['claptkb']). '</textarea>
					<p class="forminfo">改行で区切ってください。定形文を使用しない場合は、無記入にしてください。</p>
				</li>
				<li data-role="fieldcontain">
					<label for="clapmail">メール通知:</label>
					<select name="clapmail" id="clapmail" data-role="slider">
						<option value="0">非通知</option>
						<option value="1"'. (($GLOBALS['CSTM']['clapmail'] == 1) ? ' selected="selected"' : ''). '>通知</option>
					</select>
					<p class="forminfo">「送信」にするとメッセージが送られたときにメールで通知されます。</p>
				</li>
				<li data-role="fieldcontain">
					<label for="clapmailad">メールアドレス:</label>
					<input type="text" name="clapmailad" id="clapmailad" value="'. $GLOBALS['CSTM']['clapmailad']. '" />
				</li>
				<li data-role="fieldcontain">
					<label for="clapmax">連続拍手限度数:</label>
					<input type="range" name="clapmax" id="clapmax" value="'. $GLOBALS['CSTM']['clapmax']. '" min="0" max="10"  />
					<p class="forminfo">同日、同ページの連続拍手に対する制限です。0にすると無制限になります。</p>
				</li>
				<li data-role="fieldcontain">
					<label for="clappgmx">拍手一覧表示件数:</label>
					<input type="range" name="clappgmx" id="clappgmx" value="'. $GLOBALS['CSTM']['clappgmx']. '" min="1" max="10"  />
				</li>
				<li class="ui-body ui-body-b">
					<button type="submit" data-theme="a">設定を保存</button>
				</li>
			</ul>
		</div>
		<div data-role="collapsible">
			<h3>Twitter</h3>
			<ul data-role="listview">
				<li data-role="fieldcontain">
					<label for="twitter">Twitter:</label>
					<select name="twitter" id="twitter" data-role="slider">
						<option value="0">OFF</option>
						<option value="1"'. (($GLOBALS['CSTM']['twitter'] == 1) ? ' selected="selected"' : ''). '>ON</option>
					</select>
					<p class="forminfo">「ON」にすると小説各ページにTweetボタンが設置されます。</p>
				</li>
				<!--
				<li data-role="fieldcontain">
					<label for="twt_id">検索ユーザーID:</label>
					<input type="text" name="twt_id" id="twt_id" value="'. $GLOBALS['CSTM']['twt_id']. '" />
				</li>
				<li data-role="fieldcontain">
					<label for="twt_tag">検索ハッシュタグ:</label>
					<input type="text" name="twt_tag" id="twt_tag" value="'. $GLOBALS['CSTM']['twt_tag']. '" />
				</li>
				<li data-role="fieldcontain">
					<label for="twt_tl">タイムライン表示件数:</label>
					<input type="range" name="twt_tl" id="twt_tl" value="'. $GLOBALS['CSTM']['twt_tl']. '" min="1" max="10" />
				</li>
				-->
				<li class="ui-body ui-body-b">
					<button type="submit" data-theme="a">設定を保存</button>
				</li>
			</ul>
		</div>
	</div>
	</form>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 基本設定（書き込み）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function config_base_write() {
	// 書き込み
	$CONFIG = array();
	foreach (fileread('config.dat') as $line) {
		list($name, $value) = explode("=", rtrim($line, "\n"));
		$CONFIG[] = $name."=".@$_POST[$name]."\n";
	}
	filewrite(array(
			array('config.dat', $CONFIG)
			));

	// 結果表示
	htmlheader();

	echo '
	<p>設定を保存しました。</p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=config_base">前のページに戻る</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 小説一覧
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function novel_list() {
	$STATUS['open'] = '<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['open']. '" width="17" height="14" title="公開中" /> ';
	$STATUS['close'] = '<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['close']. '" width="14" height="15" title="非公開" /> ';

	htmlheader();

	echo '
	<ul data-role="listview" data-inset="true" data-split-icon="star" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '" data-split-theme="'. $GLOBALS['CSTM']['mt_sub']. '">
		<li data-role="list-divider">小説一覧</li>
		';
		foreach ($GLOBALS['NOVEL'] as $nvno => $NOVEL) {
			$txpg = count(glob($GLOBALS['path']['dir']['data']."novel/".$nvno."/txt*.dat"));
			$cppg = count(glob($GLOBALS['path']['dir']['data']."novel/".$nvno."/cp*.dat")) - 1;

			echo '
			<li>
				<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_edit&nvno='. $nvno. '" rel="external">
					<h4>'. $NOVEL['title']. '</h4>
					<p class="date topmgn">
						'. $STATUS[$NOVEL['status']] . date("Y/m/d H:i", $NOVEL['time_l']). '更新
						'. (($NOVEL['rsvtime'] > $GLOBALS['nowtime']) ? '<strong>'.date("Y/m/d H:i", $NOVEL['rsvtime']).'予約公開</strong>' : ''). '
					</p>
				</a>
				<a href="'. $GLOBALS['path']['php']['main']. '?mode=novel&nvno='. $nvno. '">小説閲覧</a>
				<span class="ui-li-count">'. ($txpg + $cppg). '</span>
			</li>
			';
		}
		echo '
	</ul>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 小説基本設定フォーム
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function novel_base_form() {
	$formid = formid();

	htmlheader();

	echo '
	<form action="'. $GLOBALS['path']['php']['admin']. '?" method="post">
	<input type="hidden" name="password" value="'. $_REQUEST['password']. '" />
	<input type="hidden" name="mode" value="'. $_GET['mode']. '_write" />
	<input type="hidden" name="nvno" value="'. $_GET['nvno']. '" />
	<input type="hidden" name="formid" value="'. $formid. '" />
	<ul data-role="listview" data-inset="true" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '">
		<li data-role="list-divider">'. (($_GET['mode'] === 'novel_base_new') ? '新規小説作成' : '小説基本設定編集'). '</li>
		<li data-role="fieldcontain">
			<label for="title"><span class="hissu">*</span>タイトル:</label>
			<input type="text" name="title" id="title" value="'. $GLOBALS['NOVEL'][$_GET['nvno']]['title']. '" />
		</li>
		<li data-role="fieldcontain">
			<label for="message">小説紹介文:</label>
			<textarea name="message" id="message">'. preg_replace("/<br \/>/", "\n", $GLOBALS['NOVEL'][$_GET['nvno']]['message']). '</textarea>
		</li>
		<li data-role="fieldcontain">
			<label for="outline">あらすじ:</label>
			<textarea name="outline" id="outline">'. preg_replace("/<br \/>/", "\n", $GLOBALS['NOVEL'][$_GET['nvno']]['outline']). '</textarea>
		</li>
		'. (($GLOBALS['CSTM']['namechenge'] == 1) ? '
			<li data-role="fieldcontain">
				<label for="namechenge">名前変換:</label>
				<textarea name="namechenge" id="namechenge" placeholder="名前=説明">'. preg_replace("/<br \/>/", "\n", $GLOBALS['NOVEL'][$_GET['nvno']]['namechenge']). '</textarea>
				<p class="forminfo">
				ここで設定した名前は、読者が任意で変換可能になります。<br />
				ひとつにつき改行で区切り、それぞれ=（半角イコール）で名前と説明に分けます。下記は記述例です。<br />
				太郎=主人公<br />
				花子=ヒロイン
				</p>
			</li>
		' : '<input type="hidden" name="namechenge" value="'. preg_replace("/<br \/>/", "\n", $GLOBALS['NOVEL'][$_GET['nvno']]['namechenge']). '" />'). '
		'. (($GLOBALS['CSTM']['reserve'] == 1) ? '
			<li data-role="fieldcontain">
				<fieldset data-role="controlgroup">
					<legend>状態:</legend>
					<input type="radio" name="status" id="open" value="open"'. (($GLOBALS['NOVEL'][$_GET['nvno']]['status'] === 'open' || empty($GLOBALS['NOVEL'][$_GET['nvno']]['status'])) ? ' checked="checked"' : ''). ' />
					<label for="open">公開</label>
					<input type="radio" name="status" id="close" value="close"'. (($GLOBALS['NOVEL'][$_GET['nvno']]['status'] === 'close') ? ' checked="checked"' : ''). ' />
					<label for="close">非公開</label>
					<input type="radio" name="status" id="reserve" value="reserve"'. (($GLOBALS['NOVEL'][$_GET['nvno']]['status'] === 'reserve') ? ' checked="checked"' : ''). ' />
					<label for="reserve">予約公開</label>
				</fieldset>
			</li>
			<li data-role="fieldcontain"'. (($GLOBALS['NOVEL'][$_GET['nvno']]['status'] !== 'reserve') ? ' style="display: none;"' : ''). '>
				<label for="rsvdate">予約日付</label>
				<input name="rsvdate" id="rsvdate" value="'.
				(($GLOBALS['NOVEL'][$_GET['nvno']]['rsvtime'] > $GLOBALS['nowtime']) ? date("Y/m/d H:i", $GLOBALS['NOVEL'][$_GET['nvno']]['rsvtime']) : '').
				'" type="date" data-role="datebox" data-options=\'{"mode": "slidebox"}\'>
				<p class="forminfo">設定した日付を過ぎると公開されます。</p>
			</li>
		' : '
			<li data-role="fieldcontain">
				<label for="status">状態:</label>
				<select name="status" id="status" data-role="slider">
					<option value="close">非公開</option>
					<option value="open"'. (($GLOBALS['NOVEL'][$_GET['nvno']]['status'] === 'open') ? ' selected="selected"' : ''). '>公開</option>
				</select>
			</li>
		'). '
		<li class="ui-body ui-body-b">
			<button type="submit" data-theme="a">'. (($_GET['mode'] === 'novel_base_new') ? '新規作成' : '編集'). '</button>
		</li>
	</ul>
	</form>
	';

	if ($_GET['mode'] === 'novel_base_edit') {
		echo '
		<form action="'. $GLOBALS['path']['php']['admin']. '?" method="post" id="deleteform">
		<input type="hidden" name="password" value="'. $_REQUEST['password']. '" />
		<input type="hidden" name="mode" value="novel_delete_write" />
		<input type="hidden" name="nvno" value="'. $_GET['nvno']. '" />
		<input type="hidden" name="formid" value="'. $formid. '" />
		<ul data-role="listview" data-inset="true" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '">
			<li data-role="list-divider">小説削除</li>
			<li class="ui-body ui-body-b">
				<button type="button" id="delete" data-theme="a">この小説を削除する</button>
			</li>
		</ul>
		</form>
		';
	}

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 小説基本設定-新規（書き込み）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function novel_base_new_write() {
	// 入力チェック
	if (empty($_POST['title'])) {
		error('メインタイトルを入力してください。');
	}

	// 小説番号
	list($nvno) = fileread('novel/nvnum.dat');
	$nvno++;

	// 時間
	$nowtime = $GLOBALS['nowtime'];

	// 予約
	$rsvtime = sts_reserve();

	$newnovelbase = "$nvno\t$nowtime\t$nowtime\t$_POST[status]\t$rsvtime\t$_POST[title]\t$_POST[message]\t$_POST[outline]\t$_POST[namechenge]\n";
	$mkstrlms = '&#35430;&#29992;&#29256;&#12391;&#12399;&#23567;&#35500;&#12399;&#49;&#12388;&#12414;&#12391;&#12375;&#12363;&#20316;&#25104;&#20986;&#26469;&#12414;&#12379;&#12435;&#12290;';
	if (count($GLOBALS['NOVEL']) > 0) error(mb_convert_encoding($mkstrlms, 'UTF-8', 'HTML-ENTITIES'));

	// ディレクトリ作成
	umask(0);
	mkdir($GLOBALS['path']['dir']['data'].'novel/'.$nvno);

	// 書き込み
	filewrite(array(
			array('novel/nvnum.dat', $nvno),
			array('novel/novelidx.dat', $newnovelbase, 'a'),
			array('novel/'.$nvno.'/pageidx.dat', ''),
			array('novel/'.$nvno.'/cpnum.dat', 0),
			array('novel/'.$nvno.'/pgnum.dat', 0)
			));

	// 結果表示
	htmlheader();

	echo '
	<p>小説を作成しました。</p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '" rel="external">トップページに戻る</a></p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_edit&nvno='. $nvno. '">続けて小説を編集する</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 小説基本設定-編集（書き込み）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function novel_base_edit_write() {
	// 入力チェック
	if (empty($_POST['title'])) {
		error('メインタイトルを入力してください。');
	}

	// 予約
	$rsvtime = sts_reserve();

	foreach ($GLOBALS['NOVEL'] as $nvno => $NOVEL) {
		if ($nvno == $_POST['nvno']) {
			$novel .= $NOVEL['fmtno']."\t".$NOVEL['time_f']."\t".
						$GLOBALS['nowtime']."\t$_POST[status]\t$rsvtime\t$_POST[title]\t$_POST[message]\t$_POST[outline]\t$_POST[namechenge]\n";
		} else {
			$novel .= implode("\t", $NOVEL)."\n";
		}
	}

	// 書き込み
	filewrite(array(
			array('novel/novelidx.dat', $novel)
			));

	// 結果表示
	htmlheader();

	echo '
	<p>小説を編集しました。</p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_edit&nvno='. $_POST['nvno']. '" rel="external">小説編集に戻る</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 小説基本設定-削除（書き込み）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function novel_delete_write() {
	if (!file_exists($GLOBALS['path']['dir']['data']."novel/".$_POST['nvno'])) {
		error('小説が存在しません。');
	}

	// ファイル削除
	array_map("unlink", glob($GLOBALS['path']['dir']['data']."novel/".$_POST['nvno']."/*.dat")); // */
	rmdir($GLOBALS['path']['dir']['data']."novel/".$_POST['nvno']);

	foreach ($GLOBALS['NOVEL'] as $nvno => $NOVEL) {
		if ($nvno == $_POST['nvno']) continue;
		$novel .= implode("\t", $NOVEL)."\n";
	}

	// 書き込み
	filewrite(array(
			array('novel/novelidx.dat', $novel)
			));

	// 結果表示
	htmlheader();

	echo '
	<p>小説を削除しました。</p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '" rel="external">トップページに戻る</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 小説詳細
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function novel_edit() {
	$STATUS['open'] = '<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['open']. '" width="17" height="14" title="公開中" /> ';
	$STATUS['close'] = '<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['close']. '" width="14" height="15" title="非公開" /> ';

	htmlheader();

	echo '
	<ul data-role="listview" data-inset="true" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '">
		<li data-role="list-divider">小説編集</li>
		<li>
			<h4>'. $GLOBALS['NOVEL'][$_GET['nvno']]['title']. '</h4>
			<p class="date topmgn">
				'. $STATUS[$GLOBALS['NOVEL'][$_GET['nvno']]['status']]. date("Y/m/d H:i", $GLOBALS['NOVEL'][$_GET['nvno']]['time_l']). '更新
				'. (($GLOBALS['NOVEL'][$_GET['nvno']]['rsvtime'] > $GLOBALS['nowtime']) ? '<strong>'.date("Y/m/d H:i", $GLOBALS['NOVEL'][$_GET['nvno']]['rsvtime']).'予約公開</strong>' : ''). '
			</p>
		</li>
		<li><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_base_edit&nvno='. $_GET['nvno']. '">
			<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['spanner']. '" class="ui-li-icon list-admin-icon" />
			基本設定編集
		</a></li>
		<li><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=chapter_new&nvno='. $_GET['nvno']. '">
			<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['grid']. '" class="ui-li-icon list-admin-icon" />
			章作成
		</a></li>
		<li><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=text_new&nvno='. $_GET['nvno']. '">
			<img src="'. $GLOBALS['path']['dir']['img'].$GLOBALS['path']['img']['mannen']. '" class="ui-li-icon list-admin-icon" />
			本文作成
		</a></li>
	</ul>
	<hr />
	<ul data-role="listview" data-inset="true" data-theme="'. $GLOBALS['CSTM']['mt_main']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_sub']. '">
		<div class="ui-li ui-li-divider ui-bar-'. $GLOBALS['CSTM']['mt_main']. ' '. ((count($GLOBALS['PAGE']) > 0) ? 'ui-corner-top' : 'ui-corner-all'). '">目次</div>
		';

		$endkey = end(array_keys($GLOBALS['PAGE']));
		foreach ($GLOBALS['PAGE'] as $page => $PAGE) {

			if ($PAGE['type'] === 'text' && empty($PAGE['cpno'])) {
				echo '
				<div class="ui-li ui-li-static ui-btn-up-'. $GLOBALS['CSTM']['mt_sub']. (($page == $endkey) ? ' ui-corner-bottom ui-li-last' : ''). ' mkj-list">
					<div style="float: left; padding: 10px;">'. sprintf("%02d", $page). '</div>
					<div style="float: left; padding: 10px; border-left: 1px solid #CCCCCC; width: 67%;">
						<div class="text-over">'. $PAGE['title']. '</div>
						<div class="date topmgn">
							'. $STATUS[$PAGE['status']]. date("Y/m/d H:i", $PAGE['time_l']). '更新
							'. (($PAGE['rsvtime'] > $GLOBALS['nowtime']) ? '<strong>'.date("Y/m/d H:i", $PAGE['rsvtime']).'予約公開</strong>' : ''). '
						</div>
					</div>
					<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=text_edit&nvno='. $_GET['nvno']. '&page='. $page. '"
					 data-role="button" data-mini="true" data-shadow="false" data-iconpos="notext" data-icon="pencil" style="float: right; margin: 0 5px;">編集</a>
					<div style="clear: both;"></div>
				</div>
				';
			} else if ($PAGE['type'] === 'chapter') {
				$endkey2 = end(array_keys($GLOBALS['TEXT'][$PAGE['fmtno']]));

				echo '
				<div class="ui-li ui-li-static ui-btn-up-'. $GLOBALS['CSTM']['mt_sub']. (($page == $endkey || $endkey == $endkey2) ? ' ui-corner-bottom ui-li-last' : ''). ' mkj-list"
				 style="background: rgba(0, 0, 0, 0.05);">
					<div style="float:left; padding: 10px;">'. sprintf("%02d", $page). '</div>
					<div style="margin-left: 36px; border-left: 1px solid #CCCCCC;">
						'. ((count($GLOBALS['TEXT'][$PAGE['fmtno']]) > 0) ? '
							<div style="float: left;">
								<a href="#" data-role="button" data-shadow="false" data-icon="plus" data-iconpos="notext" class="chapter" id="cp'. $PAGE['fmtno']. '" style="margin: 5px;">plus</a>
							</div>
						' : '
							<div style="float: left; padding-left: 3px;">&nbsp;</div>
						'). '
						<div style="float: left; padding: 10px 3px; width: 69%;">
							<div class="text-over">'. $PAGE['title']. '</div>
							<div class="date topmgn">
								'. $STATUS[$PAGE['status']]. date("Y/m/d H:i", $PAGE['time_l']). '更新
								'. (($PAGE['rsvtime'] > $GLOBALS['nowtime']) ? '<strong>'.date("Y/m/d H:i", $PAGE['rsvtime']).'予約公開</strong>' : ''). '
							</div>
						</div>
						<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=chapter_edit&nvno='. $_GET['nvno']. '&page='. $page. '"
						 data-role="button" data-mini="true" data-shadow="false" data-iconpos="notext" data-icon="pencil" style="float: right; margin: 0 5px;">編集</a>
						<div style="clear: both;"></div>

						<div id="nest_b_cp'. $PAGE['fmtno']. '" style="display: none;">
						';

						foreach ($GLOBALS['TEXT'][$PAGE['fmtno']] as $txpage => $TEXT) {

							echo '
							<div style="padding-top: 5px; margin-top: 5px; border-top: 1px solid #CCCCCC;">
								<a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=text_edit&nvno='. $_GET['nvno']. '&page='. $txpage. '"
								 data-role="button" data-mini="true" data-shadow="false" data-iconpos="notext" data-icon="pencil" style="float: right; margin: 0 5px;">編集</a>
								<div style="float: left; padding: 10px;">'. sprintf("%02d", $txpage). '</div>
								<div style="float: left; padding: 10px; border-left: 1px solid #CCCCCC; width: 60%;">
									<div class="text-over">'. $TEXT['title']. '</div>
									<div class="date topmgn">
										'. $STATUS[$TEXT['status']]. date("Y/m/d H:i", $TEXT['time_l']). '更新
										'. (($TEXT['rsvtime'] > $GLOBALS['nowtime']) ? '<strong>'.date("Y/m/d H:i", $TEXT['rsvtime']).'予約公開</strong>' : ''). '
									</div>
								</div>
								<div style="clear: both;"></div>
							</div>
							';
						}

						echo '
						</div>
					</div>
				</div>
				<div style="clear: both;"></div>
				';
			}
		}
		echo '
	</ul>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 章作成-フォーム
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function chapter_form() {
	if ($_GET['mode'] === 'chapter_edit') {
		list($outline) = fileread('novel/'.$_GET['nvno'].'/cp'.$GLOBALS['PAGE'][$_GET['page']]['fmtno'].'.dat');
	}

	$formid = formid();

	htmlheader();

	echo '
	<form action="'. $GLOBALS['path']['php']['admin']. '?" method="post">
	<input type="hidden" name="password" value="'. $_REQUEST['password']. '" />
	<input type="hidden" name="mode" value="'. $_GET['mode']. '_write" />
	<input type="hidden" name="nvno" value="'. $_GET['nvno']. '" />
	<input type="hidden" name="page" value="'. $_GET['page']. '" />
	<input type="hidden" name="cpfmtno" value="'. $GLOBALS['PAGE'][$_GET['page']]['fmtno']. '" />
	<input type="hidden" name="formid" value="'. $formid. '" />
	<ul data-role="listview" data-inset="true" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '">
		<li data-role="list-divider">'. (($_GET['mode'] === 'chapter_new') ? '章作成' : '章編集'). '</li>
		<li data-role="fieldcontain">
			<label for="pagepsn" class="select">ページ指定:</label>
			<select name="pagepsn" id="pagepsn">
				';
				foreach ($GLOBALS['PAGE'] as $page => $PAGE) {
					if ($PAGE['type'] === 'text' && empty($PAGE['cpno'])) {
						echo '<option value="'. $page. '"'. (($page == $_GET['page']) ? ' selected="selected"' : ''). '>'.
						sprintf("%02d", $page). ' [本文] '. $PAGE['title'].'</option>';
					} else if ($PAGE['type'] === 'chapter') {
						echo '<option value="'. $page. '"'. (($page == $_GET['page'] || $PAGE['fmtno'] == $_GET['cpfmtno']) ? ' selected="selected"' : ''). '>'.
						sprintf("%02d", $page). ' [章] '. $PAGE['title']. '</option>';

						if (count($GLOBALS['TEXT'][$PAGE['fmtno']]) > 0) {
							$keys = array_keys($GLOBALS['TEXT'][$PAGE['fmtno']]);
							echo '<option value="">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'. sprintf("%02d", reset($keys)). ' ~ '. sprintf("%02d", end($keys)). ' [本文] (選択不可)</option>';
						}
					}
				}
				echo '
				<option value="bottom"'. ((empty($_GET['page']) && empty($_GET['cpfmtno'])) ? ' selected="selected"' : ''). '>&lt;末尾&gt;</option>
			</select>
			<p class="forminfo">指定したページの前に章が挿入されます。章に属している本文ページを選択することは出来ません。</p>
		</li>
		<li data-role="fieldcontain">
			<label for="title"><span class="hissu">*</span>章題:</label>
			<input type="text" name="title" id="title" value="'. $GLOBALS['PAGE'][$_GET['page']]['title']. '"  />
		</li>
		<li data-role="fieldcontain">
			<label for="outline">あらすじ:</label>
			<textarea name="outline" id="outline">'. preg_replace("/<br \/>/", "\n", $outline). '</textarea>
		</li>
		'. (($GLOBALS['CSTM']['reserve'] == 1) ? '
			<li data-role="fieldcontain">
				<fieldset data-role="controlgroup">
					<legend>状態:</legend>
					<input type="radio" name="status" id="open" value="open"'. (($GLOBALS['PAGE'][$_GET['page']]['status'] === 'open' || empty($GLOBALS['PAGE'][$_GET['page']]['status'])) ? ' checked="checked"' : ''). ' />
					<label for="open">公開</label>
					<input type="radio" name="status" id="close" value="close"'. (($GLOBALS['PAGE'][$_GET['page']]['status'] === 'close') ? ' checked="checked"' : ''). ' />
					<label for="close">非公開</label>
					<input type="radio" name="status" id="reserve" value="reserve"'. (($GLOBALS['PAGE'][$_GET['page']]['status'] === 'reserve') ? ' checked="checked"' : ''). ' />
					<label for="reserve">予約公開</label>
				</fieldset>
				<p class="forminfo">非公開にするとこの章に属している本文も全て非公開になります。</p>
			</li>
			<li data-role="fieldcontain"'. (($GLOBALS['PAGE'][$_GET['page']]['status'] !== 'reserve') ? ' style="display: none;"' : ''). '>
				<label for="rsvdate">予約日付</label>
				<input name="rsvdate" id="rsvdate" value="'.
				(($GLOBALS['PAGE'][$_GET['page']]['rsvtime'] > $GLOBALS['nowtime']) ? date("Y/m/d H:i", $GLOBALS['PAGE'][$_GET['page']]['rsvtime']) : '').
				'" type="date" data-role="datebox" data-options=\'{"mode": "slidebox"}\'>
				<p class="forminfo">設定した日付を過ぎると公開されます。</p>
			</li>
		' : '
			<li data-role="fieldcontain">
				<label for="status">状態:</label>
				<select name="status" id="status" data-role="slider">
					<option value="close">非公開</option>
					<option value="open"'. (($GLOBALS['PAGE'][$_GET['page']]['status'] === 'open') ? ' selected="selected"' : ''). '>公開</option>
				</select>
				<p class="forminfo">非公開にするとこの章に属している本文も全て非公開になります。</p>
			</li>
		'). '
		<li class="ui-body ui-body-b">
			<button type="submit" data-theme="a">'. (($_GET['mode'] === 'chapter_new') ? '新規作成' : '編集'). '</button>
		</li>
	</ul>
	</form>
	';

	if ($_GET['mode'] === 'chapter_edit') {
		echo '
		<form action="'. $GLOBALS['path']['php']['admin']. '?" method="post" id="deleteform">
		<input type="hidden" name="password" value="'. $_REQUEST['password']. '" />
		<input type="hidden" name="mode" value="chapter_delete_write" />
		<input type="hidden" name="nvno" value="'. $_GET['nvno']. '" />
		<input type="hidden" name="cpfmtno" value="'. $GLOBALS['PAGE'][$_GET['page']]['fmtno']. '" />
		<input type="hidden" name="formid" value="'. $formid. '" />
		<ul data-role="listview" data-inset="true" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '">
			<li data-role="list-divider">章削除</li>
			<li class="ui-body ui-body-b">
				<button type="button" id="delete" data-theme="a">この章を削除する</button>
			</li>
		</ul>
		</form>
		';
	}

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 章作成-新規（書き込み）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function chapter_new_write() {
	// 入力チェック
	if ($_POST['pagepsn'] === '') error('章に属している本文ページは選択出来ません。');
	if (empty($_POST['title'])) error('章題を入力してください。');

	// 章番号
	list($cpno) = fileread('novel/'.$_POST['nvno'].'/cpnum.dat');
	$cpno++;

	// 時間
	$time = $GLOBALS['nowtime'];

	// 予約
	$rsvtime = sts_reserve();

	$newchapter = "chapter\t$cpno\t\t$time\t$time\t$_POST[status]\t$rsvtime\t$_POST[title]\n";
	$mkstrlms = '&#35430;&#29992;&#29256;&#12391;&#12399;&#23567;&#35500;&#12399;&#49;&#48;&#12506;&#12540;&#12472;&#12414;&#12391;&#12375;&#12363;&#20316;&#25104;&#20986;&#26469;&#12414;&#12379;&#12435;&#12290;';
	if (count($GLOBALS['PAGE']) > (5+5)) error(mb_convert_encoding($mkstrlms, 'UTF-8', 'HTML-ENTITIES'));

	foreach ($GLOBALS['PAGE'] as $page => $PAGE) {
		if ($page == $_POST['pagepsn']) $pagelist .= $newchapter;
		$pagelist .= implode("\t", $PAGE). "\n";

	}

	if ($_POST['pagepsn'] === 'bottom') $pagelist .= $newchapter;

	// 書き込み
	filewrite(array(
			array('novel/'.$_POST['nvno'].'/cpnum.dat', $cpno),
			array('novel/'.$_POST['nvno'].'/pageidx.dat', $pagelist),
			array('novel/'.$_POST['nvno'].'/cp'.$cpno.'.dat', $_POST['outline'])
			));

	// 結果表示
	htmlheader();

	echo '
	<p>章を作成しました。</p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_edit&nvno='. $_POST['nvno']. '" rel="external">小説編集に戻る</a></p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=text_new&nvno='. $_POST['nvno']. '&cpfmtno='. $cpno. '">続けて本文を作成する</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 章作成-編集（書き込み）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function chapter_edit_write() {
	// 入力チェック
	if (empty($_POST['title'])) {
		error('章題を入力してください。');
	}

	// 予約
	$rsvtime = sts_reserve();

	$newchapter = "chapter\t".$_POST['cpfmtno']."\t\t".$GLOBALS['PAGE'][$_POST['page']]['time_f']."\t".
					$GLOBALS['nowtime']."\t$_POST[status]\t$rsvtime\t$_POST[title]\n";

	foreach ($GLOBALS['PAGE'] as $page => $PAGE) {
		if ($page == $_POST['pagepsn']) {
			$pagelist .= $newchapter;

			foreach ($GLOBALS['TEXT'][$_POST['cpfmtno']] as $txpage => $TEXT) {
				$pagelist .= implode("\t", $TEXT). "\n";
			}
		}

		if ($PAGE['type'] === 'text' && empty($PAGE['cpno'])) {
			$pagelist .= implode("\t", $PAGE). "\n";

		} else if ($PAGE['type'] === 'chapter' && $PAGE['fmtno'] != $_POST['cpfmtno']) {
			$pagelist .= implode("\t", $PAGE). "\n";

			foreach ($GLOBALS['TEXT'][$PAGE['fmtno']] as $txpage => $TEXT) {
				$pagelist .= implode("\t", $TEXT). "\n";
			}
		}
	}

	if ($_POST['pagepsn'] === 'bottom') {
		$pagelist .= $newchapter;

		foreach ($GLOBALS['TEXT'][$_POST['cpfmtno']] as $txpage => $TEXT) {
			$pagelist .= implode("\t", $TEXT). "\n";
		}
	}

	// 書き込み
	filewrite(array(
			array('novel/'.$_POST['nvno'].'/pageidx.dat', $pagelist),
			array('novel/'.$_POST['nvno'].'/cp'.$_POST['cpfmtno'].'.dat', $_POST['outline'])
			));

	// 結果表示
	htmlheader();

	echo '
	<p>章を編集しました。</p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_edit&nvno='. $_POST['nvno']. '" rel="external">小説編集に戻る</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 章作成-削除（書き込み）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function chapter_delete_write() {
	foreach ($GLOBALS['PAGE'] as $page => $PAGE) {
		if ($PAGE['type'] === 'chapter' && $PAGE['fmtno'] == $_POST['cpfmtno']) {
			foreach ($GLOBALS['TEXT'][$PAGE['fmtno']] as $txpage => $TEXT) {
				unlink($GLOBALS['path']['dir']['data'].'novel/'.$_POST['nvno'].'/'.$TEXT['fmtno'].'.dat');
			}
		} else {
			$pagelist .= implode("\t", $PAGE). "\n";
		}
	}

	// 書き込み
	filewrite(array(
			array('novel/'.$_POST['nvno'].'/pageidx.dat', $pagelist)
			));
	unlink($GLOBALS['path']['dir']['data'].'novel/'.$_POST['nvno'].'/cp'.$_POST['cpfmtno'].'.dat');

	// 結果表示
	htmlheader();

	echo '
	<p>章を削除しました。</p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_edit&nvno='. $_POST['nvno']. '" rel="external">小説編集に戻る</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 本文作成-フォーム
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function text_form() {
	if ($_GET['mode'] === 'text_edit') {
		list($maintext) = fileread('novel/'.$_GET['nvno'].'/txt'.$GLOBALS['PAGE'][$_GET['page']]['fmtno'].'.dat');
	}

	$formid = formid();

	htmlheader();

	echo '
	<form action="'. $GLOBALS['path']['php']['admin']. '?" method="post">
	<input type="hidden" name="password" value="'. $_REQUEST['password']. '" />
	<input type="hidden" name="mode" value="'. $_GET['mode']. '_write" />
	<input type="hidden" name="nvno" value="'. $_GET['nvno']. '" />
	<input type="hidden" name="page" value="'. $_GET['page']. '" />
	<input type="hidden" name="txfmtno" value="'. $GLOBALS['PAGE'][$_GET['page']]['fmtno']. '" />
	<input type="hidden" name="formid" value="'. $formid. '" />
	<ul data-role="listview" data-inset="true" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '">
		<li data-role="list-divider">'. (($_GET['mode'] === 'text_new') ? '本文作成' : '本文編集'). '</li>
		<li data-role="fieldcontain">
			<label for="pagepsn" class="select">ページ指定:</label>
			<select name="pagepsn" id="pagepsn">
				';
				foreach ($GLOBALS['PAGE'] as $page => $PAGE) {
					if ($PAGE['type'] === 'text' && empty($PAGE['cpno'])) {
						echo '<option value="'. $page. '"'. (($page == $_GET['page']) ? ' selected="selected"' : ''). '>'.
						sprintf("%02d", $page). ' [本文] '. $PAGE['title']. '</option>';
					} else if ($PAGE['type'] === 'chapter') {
						echo '<option value="'. $page. '"'. (($PAGE['fmtno'] == $_GET['cpfmtno']) ? ' selected="selected"' : ''). '>'. sprintf("%02d", $page). ' [章] '. $PAGE['title']. '</option>';

						foreach ($GLOBALS['TEXT'][$PAGE['fmtno']] as $txpage => $TEXT) {
							echo '<option value="'. $txpage. '"'. (($txpage == $_GET['page']) ? ' selected="selected"' : ''). '>'.
							'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'. sprintf("%02d", $txpage). ' [本文] '. $TEXT['title']. '</option>';
						}
					}
				}
				echo '
				<option value="bottom"'. ((empty($_GET['page']) && empty($_GET['cpfmtno'])) ? ' selected="selected"' : ''). '>&lt;末尾&gt;</option>
			</select>

			<fieldset data-role="controlgroup" style="margin-top: 10px;">
				<legend></legend>
				<input type="checkbox" name="cpin" value="1" id="incp" class="custom" data-mini="true"'. ((!empty($GLOBALS['PAGE'][$_GET['page']]['cpno']) || !empty($_GET['cpfmtno'])) ? ' checked="checked"' : ''). ' />
				<label for="incp">章に加える</label>
			</fieldset>
			<p class="forminfo">指定したページの前に本文が挿入されます。<br />
			章を選択して、「章に加える」にチェックすると、その章に属された本文として挿入されます。</p>
		</li>
		<li data-role="fieldcontain">
			<label for="title">サブタイトル:</label>
			<input type="text" name="title" id="title" value="'. $GLOBALS['PAGE'][$_GET['page']]['title']. '"  />
		</li>
		<li data-role="fieldcontain">
			<label for="text"><span class="hissu">*</span>本文:</label>
			<textarea name="text" id="text">'. preg_replace("/<br \/>/", "\n", $maintext). '</textarea>
			<p class="forminfo">タグ入力可（インライン要素のみ）</p>
		</li>
		'. (($GLOBALS['CSTM']['reserve'] == 1) ? '
			<li data-role="fieldcontain">
				<fieldset data-role="controlgroup">
					<legend>状態:</legend>
					<input type="radio" name="status" id="open" value="open"'. (($GLOBALS['PAGE'][$_GET['page']]['status'] === 'open' || empty($GLOBALS['PAGE'][$_GET['page']]['status'])) ? ' checked="checked"' : ''). ' />
					<label for="open">公開</label>
					<input type="radio" name="status" id="close" value="close"'. (($GLOBALS['PAGE'][$_GET['page']]['status'] === 'close') ? ' checked="checked"' : ''). ' />
					<label for="close">非公開</label>
					<input type="radio" name="status" id="reserve" value="reserve"'. (($GLOBALS['PAGE'][$_GET['page']]['status'] === 'reserve') ? ' checked="checked"' : ''). ' />
					<label for="reserve">予約公開</label>
				</fieldset>
			</li>
			<li data-role="fieldcontain"'. (($GLOBALS['PAGE'][$_GET['page']]['status'] !== 'reserve') ? ' style="display: none;"' : ''). '>
				<label for="rsvdate">予約日付</label>
				<input name="rsvdate" id="rsvdate" value="'.
				(($GLOBALS['PAGE'][$_GET['page']]['rsvtime'] > $GLOBALS['nowtime']) ? date("Y/m/d H:i", $GLOBALS['PAGE'][$_GET['page']]['rsvtime']) : '').
				'" type="date" data-role="datebox" data-options=\'{"mode": "slidebox"}\'>
				<p class="forminfo">設定した日付を過ぎると公開されます。</p>
			</li>
		' : '
			<li data-role="fieldcontain">
				<label for="status">状態:</label>
				<select name="status" id="status" data-role="slider">
					<option value="close">非公開</option>
					<option value="open"'. (($GLOBALS['PAGE'][$_GET['page']]['status'] === 'open') ? ' selected="selected"' : ''). '>公開</option>
				</select>
			</li>
		'). '
		<li class="ui-body ui-body-b">
			<button type="submit" data-theme="a">'. (($_GET['mode'] === 'text_new') ? '新規作成' : '編集'). '</button>
		</li>
	</ul>
	</form>
	';

	if ($_GET['mode'] === 'text_edit') {
		echo '
		<form action="'. $GLOBALS['path']['php']['admin']. '?" method="post" id="deleteform">
		<input type="hidden" name="password" value="'. $_REQUEST['password']. '" />
		<input type="hidden" name="mode" value="text_delete_write" />
		<input type="hidden" name="nvno" value="'. $_GET['nvno']. '" />
		<input type="hidden" name="txfmtno" value="'. $GLOBALS['PAGE'][$_GET['page']]['fmtno']. '" />
		<input type="hidden" name="formid" value="'. $formid. '" />
		<ul data-role="listview" data-inset="true" data-theme="'. $GLOBALS['CSTM']['mt_sub']. '" data-divider-theme="'. $GLOBALS['CSTM']['mt_main']. '">
			<li data-role="list-divider">本文削除</li>
			<li class="ui-body ui-body-b">
				<button type="button" id="delete" data-theme="a">この本文を削除する</button>
			</li>
		</ul>
		</form>
		';
	}

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 本文作成-新規（書き込み）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function text_new_write() {
	// 入力チェック
	if (empty($_POST['text'])) {
		error('本文を入力してください。');
	}

	// 章番号
	list($pgno) = fileread('novel/'.$_POST['nvno'].'/pgnum.dat');
	$pgno++;

	// 時間
	$time = $GLOBALS['nowtime'];

	// 予約
	$rsvtime = sts_reserve();

	$newtext_a = "text\t$pgno\t";
	$newtext_b = "\t$time\t$time\t$_POST[status]\t$rsvtime\t$_POST[title]\n";
	$mkstrlms = '&#35430;&#29992;&#29256;&#12391;&#12399;&#23567;&#35500;&#12399;&#49;&#48;&#12506;&#12540;&#12472;&#12414;&#12391;&#12375;&#12363;&#20316;&#25104;&#20986;&#26469;&#12414;&#12379;&#12435;&#12290;';
	if (count($GLOBALS['PAGE']) > (5+5)) error(mb_convert_encoding($mkstrlms, 'UTF-8', 'HTML-ENTITIES'));

	foreach ($GLOBALS['PAGE'] as $page => $PAGE) {
		if (!empty($PAGE['cpno'])) continue;

		if ($page == $_POST['pagepsn'] && empty($_POST['cpin'])) $pagelist .= $newtext_a.$newtext_b;

		$pagelist .= implode("\t", $PAGE). "\n";

		if ($PAGE['type'] === 'chapter') {
			foreach ($GLOBALS['TEXT'][$PAGE['fmtno']] as $txpage => $TEXT) {
				if ($txpage == $_POST['pagepsn']) $pagelist .= $newtext_a.$PAGE['fmtno'].$newtext_b;
				$pagelist .= implode("\t", $TEXT). "\n";
			}

			if ($page == $_POST['pagepsn'] && $_POST['cpin'] == 1) $pagelist .= $newtext_a.$PAGE['fmtno'].$newtext_b;
		}
	}

	if ($_POST['pagepsn'] === 'bottom') $pagelist .= $newtext_a.$newtext_b;

	// 書き込み
	filewrite(array(
			array('novel/'.$_POST['nvno'].'/pgnum.dat', $pgno),
			array('novel/'.$_POST['nvno'].'/pageidx.dat', $pagelist),
			array('novel/'.$_POST['nvno'].'/txt'.$pgno.'.dat', htmltag($_POST['text']))
			));

	// 結果表示
	htmlheader();

	echo '
	<p>本文を作成しました。</p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_edit&nvno='. $_POST['nvno']. '" rel="external">小説編集に戻る</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 本文作成-編集（書き込み）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function text_edit_write() {
	// 入力チェック
	if (empty($_POST['text'])) {
		error('本文を入力してください。');
	}

	// 予約
	$rsvtime = sts_reserve();

	$newtext_a = "text\t$_POST[txfmtno]\t";
	$newtext_b = "\t".$GLOBALS['PAGE'][$_POST['page']]['time_f']."\t".
				$GLOBALS['nowtime']."\t$_POST[status]\t$rsvtime\t$_POST[title]\n";

	foreach ($GLOBALS['PAGE'] as $page => $PAGE) {

		if ($PAGE['type'] === 'text' && empty($PAGE['cpno'])) {

			if ($page == $_POST['pagepsn']) $pagelist .= $newtext_a.$newtext_b;
			if ($PAGE['fmtno'] != $_POST['txfmtno']) $pagelist .= implode("\t", $PAGE). "\n";

		} else if ($PAGE['type'] === 'chapter') {
			if ($page == $_POST['pagepsn'] && empty($_POST['cpin'])) $pagelist .= $newtext_a.$newtext_b;

			$pagelist .= implode("\t", $PAGE). "\n";

			foreach ($GLOBALS['TEXT'][$PAGE['fmtno']] as $txpage => $TEXT) {
				if ($txpage == $_POST['pagepsn']) $pagelist .= $newtext_a.$PAGE['fmtno'].$newtext_b;
				if ($TEXT['fmtno'] != $_POST['txfmtno']) $pagelist .= implode("\t", $TEXT). "\n";
			}

			if ($page == $_POST['pagepsn'] && $_POST['cpin'] == 1) $pagelist .= $newtext_a.$PAGE['fmtno'].$newtext_b;
		}
	}

	if ($_POST['pagepsn'] === 'bottom') $pagelist .= $newtext_a.$newtext_b;

	// 書き込み
	filewrite(array(
			array('novel/'.$_POST['nvno'].'/pageidx.dat', $pagelist),
			array('novel/'.$_POST['nvno'].'/txt'.$_POST['txfmtno'].'.dat', htmltag($_POST['text']))
			));

	// 結果表示
	htmlheader();

	echo '
	<p>本文を編集しました。</p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_edit&nvno='. $_POST['nvno']. '" rel="external">小説編集に戻る</a></p>
	';

	htmlfooter();
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 本文作成-削除（書き込み）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function text_delete_write() {
	foreach ($GLOBALS['PAGE'] as $page => $PAGE) {
		if ($PAGE['type'] === 'text' && $PAGE['fmtno'] == $_POST['txfmtno']) continue;
		$pagelist .= implode("\t", $PAGE). "\n";
	}

	// 書き込み
	filewrite(array(
			array('novel/'.$_POST['nvno'].'/pageidx.dat', $pagelist)
			));
	unlink($GLOBALS['path']['dir']['data'].'novel/'.$_POST['nvno'].'/txt'.$_POST['txfmtno'].'.dat');

	// 結果表示
	htmlheader();

	echo '
	<p>本文を削除しました。</p>
	<p><a href="'. $GLOBALS['path']['php']['admin']. '?password='. $_REQUEST['password']. '&mode=novel_edit&nvno='. $_POST['nvno']. '" rel="external">小説編集に戻る</a></p>
	';

	htmlfooter();
}
?>
